MWAWSpreadsheetListener Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
MWAWSpreadsheetListener Class Referencefinal

This class contents the main functions needed to create a spreadsheet processing Document. More...

`#include <MWAWSpreadsheetListener.hxx>`

Inheritance diagram for MWAWSpreadsheetListener:

## Public Member Functions
| MWAWSpreadsheetListener (MWAWParserState &parserState, std::vector< MWAWPageSpan > const &pageList, librevenge::RVNGSpreadsheetInterface *documentInterface)
| constructor More...
| MWAWSpreadsheetListener (MWAWParserState &parserState, MWAWBox2f const &box, librevenge::RVNGSpreadsheetInterface *documentInterface)
| simplified constructor (can be used for a embedded spreadsheet with one page). More...
| ~MWAWSpreadsheetListener () final
| destructor More...
Type | getType () const final
| returns the listener type More...
void | setDocumentMetaData (librevenge::RVNGPropertyList const &metadata) final
| sets the documents metadata More...
void | setDocumentLanguage (std::string const &locale) final
| sets the documents language More...
void | startDocument () final
| starts the document More...
void | endDocument (bool sendDelayedSubDoc=true) final
| ends the document More...
bool | isDocumentStarted () const final
| returns true if a document is opened More...
void | handleSubDocument (MWAWSubDocumentPtr const &subDocument, libmwaw::SubDocumentType subDocumentType) final
| function called to add a subdocument More...
bool | isSubDocumentOpened (libmwaw::SubDocumentType &subdocType) const final
| returns try if a subdocument is open More...
bool | openFrame (MWAWPosition const &pos, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle()) final
| tries to open a frame More...
void | closeFrame () final
| tries to close a frame More...
bool | openGroup (MWAWPosition const &pos) final
| open a group (not implemented) More...
void | closeGroup () final
| close a group (not implemented) More...
bool | canWriteText () const final
| returns true if we can add text data More...
bool | isPageSpanOpened () const final
| returns true if a page is opened More...
MWAWPageSpan const & | getPageSpan () final
| returns the current page span More...
bool | insertHeader (MWAWSubDocumentPtr const &subDocument, librevenge::RVNGPropertyList const &extras) final
| insert a header More...
bool | insertFooter (MWAWSubDocumentPtr const &subDocument, librevenge::RVNGPropertyList const &extras) final
| insert a footer More...
bool | isHeaderFooterOpened () const final
| returns true if the header/footer is open More...
void | openSheet (std::vector< float > const &colWidth, librevenge::RVNGUnit unit, std::vector< int > const &repeatColWidthNumber=std::vector< int >(), std::string const &name="")
| opens a sheet More...
void | closeSheet ()
| closes this sheet More...
void | openSheetRow (float h, librevenge::RVNGUnit unit, int numRepeated=1)
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
void | closeSheetRow ()
| closes this row More...
void | openSheetCell (MWAWCell const &cell, MWAWCellContent const &content, int numRepeated=1)
| open a cell More...
void | closeSheetCell ()
| close a cell More...
void | insertChart (MWAWPosition const &pos, MWAWChart &chart, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| adds a chart in given position More...
void | insertChar (uint8_t character) final
| adds a basic character, .. More...
void | insertCharacter (unsigned char c) final
| insert a character using the font converter to find the utf8 character More...
int | insertCharacter (unsigned char c, MWAWInputStreamPtr &input, long endPos=-1) final
| insert a character using the font converter to find the utf8 character and if needed, input to read extra character. More...
void | insertUnicode (uint32_t character) final
| adds an unicode character. More...
void | insertUnicodeString (librevenge::RVNGString const &str) final
| adds a unicode string More...
void | insertTab () final
| adds a tab More...
void | insertEOL (bool softBreak=false) final
| adds an end of line ( by default an hard one) More...
void | setFont (MWAWFont const &font) final
| sets the font More...
MWAWFont const & | getFont () const final
| returns the actual font More...
bool | isParagraphOpened () const final
| returns true if a paragraph or a list is opened More...
void | setParagraph (MWAWParagraph const &paragraph) final
| sets the paragraph More...
MWAWParagraph const & | getParagraph () const final
| returns the actual paragraph More...
void | insertField (MWAWField const &field) final
| adds a field type More...
void | openLink (MWAWLink const &link) final
| open a link More...
void | closeLink () final
| close a link More...
void | insertNote (MWAWNote const &note, MWAWSubDocumentPtr &subDocument) final
| insert a note More...
void | insertComment (MWAWSubDocumentPtr &subDocument) final
| adds comment More...
void | insertPicture (MWAWPosition const &pos, MWAWEmbeddedObject const &picture, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle()) final
| adds a picture with potential various representationin given position More...
void | insertShape (MWAWPosition const &pos, MWAWGraphicShape const &shape, MWAWGraphicStyle const &style) final
| adds a shape picture in given position More...
void | insertTextBox (MWAWPosition const &pos, MWAWSubDocumentPtr const &subDocument, MWAWGraphicStyle const &frameStyle=MWAWGraphicStyle::emptyStyle()) final
| adds a textbox in given position More...
void | insertTable (MWAWPosition const &pos, MWAWTable &table, MWAWGraphicStyle const &style=MWAWGraphicStyle::emptyStyle())
| adds a table in given position More...
void | openTable (MWAWTable const &table) final
| open a table More...
void | closeTable () final
| closes this table More...
void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false) final
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
void | closeTableRow () final
| closes this row More...
void | openTableCell (MWAWCell const &cell) final
| open a cell More...
void | closeTableCell () final
| close a cell More...
void | addEmptyTableCell (MWAWVec2i const &pos, MWAWVec2i span=MWAWVec2i(1, 1)) final
| add empty cell More...
bool | canOpenSectionAddBreak () const final
| returns true if we can add open a section, add page break, ... More...
bool | isSectionOpened () const final
| returns true if a section is opened More...
MWAWSection const & | getSection () const final
| returns the actual section More...
bool | openSection (MWAWSection const &section) final
| open a section if possible More...
bool | closeSection () final
| close a section More...
void | insertBreak (BreakType breakType) final
| inserts a break type: ColumBreak, PageBreak, .. More...
Public Member Functions inherited from MWAWListener
virtual | ~MWAWListener ()
| destructor More...
virtual void | insertTextBoxInShape (MWAWPosition const &pos, MWAWSubDocumentPtr const &subDocument, MWAWGraphicShape const &, MWAWGraphicStyle const &frameStyle=MWAWGraphicStyle::emptyStyle())
| adds a textbox in given position More...

## Protected Member Functions
void | _openPageSpan (bool sendHeaderFooters=true)
| does open a new page (low level) More...
void | _closePageSpan ()
| does close a page (low level) More...
void | _startSubDocument ()
void | _endSubDocument ()
void | _handleFrameParameters (librevenge::RVNGPropertyList &propList, MWAWPosition const &pos)
void | _openParagraph ()
void | _closeParagraph ()
void | _resetParagraphState (const bool isListElement=false)
void | _openListElement ()
| open a list level More...
void | _closeListElement ()
| close a list level More...
void | _changeList ()
| update the list so that it corresponds to the actual level More...
int | _getListId () const
| low level: find a list id which corresponds to actual list and a change of level. More...
void | _openSpan ()
void | _closeSpan ()
void | _flushText ()
void | _flushDeferredTabs ()
std::shared_ptr< MWAWSpreadsheetListenerInternal::State > | _pushParsingState ()
| creates a new parsing state (copy of the actual state) More...
void | _popParsingState ()
| resets the previous parsing state More...

## Protected Attributes
std::shared_ptr< MWAWSpreadsheetListenerInternal::DocumentState > | m_ds
| the main parse state More...
std::shared_ptr< MWAWSpreadsheetListenerInternal::State > | m_ps
| the actual local parse state More...
std::vector< std::shared_ptr< MWAWSpreadsheetListenerInternal::State > > | m_psStack
| stack of local state More...
MWAWParserState & | m_parserState
| the parser state More...
librevenge::RVNGSpreadsheetInterface * | m_documentInterface
| the document interface More...

## Private Member Functions
| MWAWSpreadsheetListener (const MWAWSpreadsheetListener &)
| copy constructor (unimplemented) More...
MWAWSpreadsheetListener & | operator= (const MWAWSpreadsheetListener &)
| operator= (unimplemented) More...

## Additional Inherited Members
Public Types inherited from MWAWListener
enum | Type { Graphic, Presentation, Spreadsheet, Text }
| the listener type More...
enum | BreakType { PageBreak =0, SoftPageBreak, ColumnBreak }
| the different break type More...

## Detailed Description

This class contents the main functions needed to create a spreadsheet processing Document.

## Constructor & Destructor Documentation

## ◆ MWAWSpreadsheetListener() [1/3]

MWAWSpreadsheetListener::MWAWSpreadsheetListener | ( | MWAWParserState & | parserState,
|  | std::vector< MWAWPageSpan > const & | pageList,
|  | librevenge::RVNGSpreadsheetInterface * | documentInterface
| ) |  |

constructor

## ◆ MWAWSpreadsheetListener() [2/3]

MWAWSpreadsheetListener::MWAWSpreadsheetListener | ( | MWAWParserState & | parserState,
|  | MWAWBox2f const & | box,
|  | librevenge::RVNGSpreadsheetInterface * | documentInterface
| ) |  |

simplified constructor (can be used for a embedded spreadsheet with one page).

Note
  the box coordinates must be given in point.

## ◆ ~MWAWSpreadsheetListener()

MWAWSpreadsheetListener::~MWAWSpreadsheetListener | ( |  | ) |
| final

destructor

## ◆ MWAWSpreadsheetListener() [3/3]

MWAWSpreadsheetListener::MWAWSpreadsheetListener | ( | const MWAWSpreadsheetListener & |  | ) |
| private

copy constructor (unimplemented)

## Member Function Documentation

## ◆ _changeList()

void MWAWSpreadsheetListener::_changeList | ( |  | ) |
| protected

update the list so that it corresponds to the actual level

Referenced by _endSubDocument(), _openSpan(), closeTableCell(), endDocument(), and insertNote().

## ◆ _closeListElement()

void MWAWSpreadsheetListener::_closeListElement | ( |  | ) |
| protected

close a list level

Referenced by _closeParagraph().

## ◆ _closePageSpan()

void MWAWSpreadsheetListener::_closePageSpan | ( |  | ) |
| protected

does close a page (low level)

Referenced by endDocument().

## ◆ _closeParagraph()

void MWAWSpreadsheetListener::_closeParagraph | ( |  | ) |
| protected

Referenced by _changeList(), _endSubDocument(), closeSheetCell(), closeTableCell(), endDocument(), insertComment(), insertEOL(), insertNote(), openSheet(), and openTable().

## ◆ _closeSpan()

void MWAWSpreadsheetListener::_closeSpan | ( |  | ) |
| protected

Referenced by _closeListElement(), _closeParagraph(), _endSubDocument(), _flushDeferredTabs(), closeLink(), insertComment(), insertNote(), and setFont().

## ◆ _endSubDocument()

void MWAWSpreadsheetListener::_endSubDocument | ( |  | ) |
| protected

Referenced by closeSheet(), closeTable(), and handleSubDocument().

## ◆ _flushDeferredTabs()

void MWAWSpreadsheetListener::_flushDeferredTabs | ( |  | ) |
| protected

Referenced by insertChar(), insertEOL(), insertField(), insertTab(), insertUnicode(), and insertUnicodeString().

## ◆ _flushText()

void MWAWSpreadsheetListener::_flushText | ( |  | ) |
| protected

Referenced by _closeSpan(), insertComment(), insertEOL(), insertField(), insertNote(), insertTab(), and openFrame().

## ◆ _getListId()

int MWAWSpreadsheetListener::_getListId | ( |  | ) | const
| protected

low level: find a list id which corresponds to actual list and a change of level.

Note
  called when the list id is not set

Referenced by _changeList().

## ◆ _handleFrameParameters()

void MWAWSpreadsheetListener::_handleFrameParameters | ( | librevenge::RVNGPropertyList & | propList,
|  | MWAWPosition const & | pos
| ) |  |
| protected

Referenced by openFrame().

## ◆ _openListElement()

void MWAWSpreadsheetListener::_openListElement | ( |  | ) |
| protected

open a list level

Referenced by _openSpan().

## ◆ _openPageSpan()

void MWAWSpreadsheetListener::_openPageSpan | ( | bool | sendHeaderFooters = `true` | ) |
| protected

does open a new page (low level)

Referenced by endDocument(), getPageSpan(), and openSheet().

## ◆ _openParagraph()

void MWAWSpreadsheetListener::_openParagraph | ( |  | ) |
| protected

Referenced by _openSpan(), insertComment(), insertNote(), and openFrame().

## ◆ _openSpan()

void MWAWSpreadsheetListener::_openSpan | ( |  | ) |
| protected

Referenced by _flushDeferredTabs(), endDocument(), handleSubDocument(), insertChar(), insertEOL(), insertField(), insertUnicode(), insertUnicodeString(), openFrame(), and openLink().

## ◆ _popParsingState()

void MWAWSpreadsheetListener::_popParsingState | ( |  | ) |
| protected

resets the previous parsing state

Referenced by closeLink(), closeSheet(), closeTable(), and handleSubDocument().

## ◆ _pushParsingState()

std::shared_ptr< MWAWSpreadsheetListenerInternal::State > MWAWSpreadsheetListener::_pushParsingState | ( |  | ) |
| protected

creates a new parsing state (copy of the actual state)

Returns
  the old one

Referenced by handleSubDocument(), openLink(), openSheet(), and openTable().

## ◆ _resetParagraphState()

void MWAWSpreadsheetListener::_resetParagraphState | ( | const bool | isListElement = `false` | ) |
| protected

Referenced by _openListElement(), and _openParagraph().

## ◆ _startSubDocument()

void MWAWSpreadsheetListener::_startSubDocument | ( |  | ) |
| protected

Referenced by handleSubDocument(), openSheet(), and openTable().

## ◆ addEmptyTableCell()

void MWAWSpreadsheetListener::addEmptyTableCell | ( | MWAWVec2i const & | pos,
|  | MWAWVec2i | span = `MWAWVec2i(1,1)`
| ) |  |
| finalvirtual

add empty cell

Implements MWAWListener.

## ◆ canOpenSectionAddBreak()

bool MWAWSpreadsheetListener::canOpenSectionAddBreak | ( |  | ) | const
| inlinefinalvirtual

returns true if we can add open a section, add page break, ...

Implements MWAWListener.

## ◆ canWriteText()

bool MWAWSpreadsheetListener::canWriteText | ( |  | ) | const
| finalvirtual

returns true if we can add text data

Implements MWAWListener.

Referenced by insertComment(), and insertNote().

## ◆ closeFrame()

void MWAWSpreadsheetListener::closeFrame | ( |  | ) |
| finalvirtual

tries to close a frame

Implements MWAWListener.

Referenced by insertPicture().

## ◆ closeGroup()

void MWAWSpreadsheetListener::closeGroup | ( |  | ) |
| finalvirtual

close a group (not implemented)

Implements MWAWListener.

## ◆ closeLink()

void MWAWSpreadsheetListener::closeLink | ( |  | ) |
| finalvirtual

close a link

Implements MWAWListener.

## ◆ closeSection()

bool MWAWSpreadsheetListener::closeSection | ( |  | ) |
| finalvirtual

close a section

Implements MWAWListener.

## ◆ closeSheet()

void MWAWSpreadsheetListener::closeSheet | ( |  | ) |

closes this sheet

Referenced by endDocument().

## ◆ closeSheetCell()

void MWAWSpreadsheetListener::closeSheetCell | ( |  | ) |

close a cell

Referenced by openSheetCell().

## ◆ closeSheetRow()

void MWAWSpreadsheetListener::closeSheetRow | ( |  | ) |

closes this row

## ◆ closeTable()

void MWAWSpreadsheetListener::closeTable | ( |  | ) |
| finalvirtual

closes this table

Implements MWAWListener.

Referenced by _endSubDocument(), and endDocument().

## ◆ closeTableCell()

void MWAWSpreadsheetListener::closeTableCell | ( |  | ) |
| finalvirtual

close a cell

Implements MWAWListener.

Referenced by addEmptyTableCell(), and openTableCell().

## ◆ closeTableRow()

void MWAWSpreadsheetListener::closeTableRow | ( |  | ) |
| finalvirtual

closes this row

Implements MWAWListener.

## ◆ endDocument()

void MWAWSpreadsheetListener::endDocument | ( | bool | sendDelayedSubDoc = `true` | ) |
| finalvirtual

ends the document

Implements MWAWListener.

## ◆ getFont()

MWAWFont const & MWAWSpreadsheetListener::getFont | ( |  | ) | const
| finalvirtual

returns the actual font

Implements MWAWListener.

## ◆ getPageSpan()

MWAWPageSpan const & MWAWSpreadsheetListener::getPageSpan | ( |  | ) |
| finalvirtual

returns the current page span

Note
  this forces the opening of a new page if no page is opened.

Implements MWAWListener.

## ◆ getParagraph()

MWAWParagraph const & MWAWSpreadsheetListener::getParagraph | ( |  | ) | const
| finalvirtual

returns the actual paragraph

Implements MWAWListener.

## ◆ getSection()

MWAWSection const & MWAWSpreadsheetListener::getSection | ( |  | ) | const
| finalvirtual

returns the actual section

Implements MWAWListener.

## ◆ getType()

Type MWAWSpreadsheetListener::getType | ( |  | ) | const
| inlinefinalvirtual

returns the listener type

Implements MWAWListener.

## ◆ handleSubDocument()

void MWAWSpreadsheetListener::handleSubDocument | ( | MWAWSubDocumentPtr const & | subDocument,
|  | libmwaw::SubDocumentType | subDocumentType
| ) |  |
| finalvirtual

function called to add a subdocument

Implements MWAWListener.

Referenced by insertComment(), insertFooter(), insertHeader(), and insertNote().

## ◆ insertBreak()

void MWAWSpreadsheetListener::insertBreak | ( | MWAWSpreadsheetListener::BreakType | breakType | ) |
| finalvirtual

inserts a break type: ColumBreak, PageBreak, ..

Implements MWAWListener.

## ◆ insertChar()

void MWAWSpreadsheetListener::insertChar | ( | uint8_t | character | ) |
| finalvirtual

adds a basic character, ..

Implements MWAWListener.

Referenced by insertCharacter().

## ◆ insertCharacter() [1/2]

void MWAWSpreadsheetListener::insertCharacter | ( | unsigned char | c | ) |
| finalvirtual

insert a character using the font converter to find the utf8 character

Implements MWAWListener.

## ◆ insertCharacter() [2/2]

int MWAWSpreadsheetListener::insertCharacter | ( | unsigned char | c,
|  | MWAWInputStreamPtr & | input,
|  | long | endPos = `-1`
| ) |  |
| finalvirtual

insert a character using the font converter to find the utf8 character and if needed, input to read extra character.

Returns
  the number of extra character read

Implements MWAWListener.

## ◆ insertChart()

void MWAWSpreadsheetListener::insertChart | ( | MWAWPosition const & | pos,
|  | MWAWChart & | chart,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |

adds a chart in given position

## ◆ insertComment()

void MWAWSpreadsheetListener::insertComment | ( | MWAWSubDocumentPtr & | subDocument | ) |
| finalvirtual

adds comment

Implements MWAWListener.

## ◆ insertEOL()

void MWAWSpreadsheetListener::insertEOL | ( | bool | softBreak = `false` | ) |
| finalvirtual

adds an end of line ( by default an hard one)

Implements MWAWListener.

## ◆ insertField()

void MWAWSpreadsheetListener::insertField | ( | MWAWField const & | field | ) |
| finalvirtual

adds a field type

Implements MWAWListener.

## ◆ insertFooter()

bool MWAWSpreadsheetListener::insertFooter | ( | MWAWSubDocumentPtr const & | subDocument,
|  | librevenge::RVNGPropertyList const & | extras
| ) |  |
| finalvirtual

insert a footer

Implements MWAWListener.

## ◆ insertHeader()

bool MWAWSpreadsheetListener::insertHeader | ( | MWAWSubDocumentPtr const & | subDocument,
|  | librevenge::RVNGPropertyList const & | extras
| ) |  |
| finalvirtual

insert a header

Implements MWAWListener.

## ◆ insertNote()

void MWAWSpreadsheetListener::insertNote | ( | MWAWNote const & | note,
|  | MWAWSubDocumentPtr & | subDocument
| ) |  |
| finalvirtual

insert a note

Must not happen excepted in corrupted document, so we do the minimum. Note that we have no choice, either we begin by closing the paragraph, ... or we reprogram handleSubDocument.

Implements MWAWListener.

## ◆ insertPicture()

void MWAWSpreadsheetListener::insertPicture | ( | MWAWPosition const & | pos,
|  | MWAWEmbeddedObject const & | picture,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |
| finalvirtual

adds a picture with potential various representationin given position

Implements MWAWListener.

## ◆ insertShape()

void MWAWSpreadsheetListener::insertShape | ( | MWAWPosition const & | pos,
|  | MWAWGraphicShape const & | shape,
|  | MWAWGraphicStyle const & | style
| ) |  |
| finalvirtual

adds a shape picture in given position

Implements MWAWListener.

## ◆ insertTab()

void MWAWSpreadsheetListener::insertTab | ( |  | ) |
| finalvirtual

adds a tab

Implements MWAWListener.

## ◆ insertTable()

void MWAWSpreadsheetListener::insertTable | ( | MWAWPosition const & | pos,
|  | MWAWTable & | table,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |

adds a table in given position

## ◆ insertTextBox()

void MWAWSpreadsheetListener::insertTextBox | ( | MWAWPosition const & | pos,
|  | MWAWSubDocumentPtr const & | subDocument,
|  | MWAWGraphicStyle const & | frameStyle = `MWAWGraphicStyle::emptyStyle()`
| ) |  |
| finalvirtual

adds a textbox in given position

Implements MWAWListener.

## ◆ insertUnicode()

void MWAWSpreadsheetListener::insertUnicode | ( | uint32_t | character | ) |
| finalvirtual

adds an unicode character.

By convention if character=0xfffd(undef), no character is added

Implements MWAWListener.

Referenced by insertChar(), and insertCharacter().

## ◆ insertUnicodeString()

void MWAWSpreadsheetListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| finalvirtual

adds a unicode string

Implements MWAWListener.

Referenced by insertField().

## ◆ isDocumentStarted()

bool MWAWSpreadsheetListener::isDocumentStarted | ( |  | ) | const
| finalvirtual

returns true if a document is opened

Implements MWAWListener.

## ◆ isHeaderFooterOpened()

bool MWAWSpreadsheetListener::isHeaderFooterOpened | ( |  | ) | const
| finalvirtual

returns true if the header/footer is open

Implements MWAWListener.

## ◆ isPageSpanOpened()

bool MWAWSpreadsheetListener::isPageSpanOpened | ( |  | ) | const
| finalvirtual

returns true if a page is opened

Implements MWAWListener.

## ◆ isParagraphOpened()

bool MWAWSpreadsheetListener::isParagraphOpened | ( |  | ) | const
| finalvirtual

returns true if a paragraph or a list is opened

Implements MWAWListener.

## ◆ isSectionOpened()

bool MWAWSpreadsheetListener::isSectionOpened | ( |  | ) | const
| inlinefinalvirtual

returns true if a section is opened

Implements MWAWListener.

## ◆ isSubDocumentOpened()

bool MWAWSpreadsheetListener::isSubDocumentOpened | ( | libmwaw::SubDocumentType & | subdocType | ) | const
| finalvirtual

returns try if a subdocument is open

Implements MWAWListener.

## ◆ openFrame()

bool MWAWSpreadsheetListener::openFrame | ( | MWAWPosition const & | pos,
|  | MWAWGraphicStyle const & | style = `MWAWGraphicStyle::emptyStyle()`
| ) |  |
| finalvirtual

tries to open a frame

Implements MWAWListener.

Referenced by insertPicture().

## ◆ openGroup()

bool MWAWSpreadsheetListener::openGroup | ( | MWAWPosition const & | pos | ) |
| finalvirtual

open a group (not implemented)

Implements MWAWListener.

## ◆ openLink()

void MWAWSpreadsheetListener::openLink | ( | MWAWLink const & | link | ) |
| finalvirtual

open a link

Implements MWAWListener.

## ◆ openSection()

bool MWAWSpreadsheetListener::openSection | ( | MWAWSection const & | section | ) |
| finalvirtual

open a section if possible

Implements MWAWListener.

## ◆ openSheet()

void MWAWSpreadsheetListener::openSheet | ( | std::vector< float > const & | colWidth,
|  | librevenge::RVNGUnit | unit,
|  | std::vector< int > const & | repeatColWidthNumber = `std::vector<int>()`,
|  | std::string const & | name = `""`
| ) |  |

opens a sheet

Note
  if defWidth is positive, add 1000 columns with size defWidth

## ◆ openSheetCell()

void MWAWSpreadsheetListener::openSheetCell | ( | MWAWCell const & | cell,
|  | MWAWCellContent const & | content,
|  | int | numRepeated = `1`
| ) |  |

open a cell

## ◆ openSheetRow()

void MWAWSpreadsheetListener::openSheetRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | int | numRepeated = `1`
| ) |  |

open a row with given height ( if h < 0.0, set min-row-height = -h )

## ◆ openTable()

void MWAWSpreadsheetListener::openTable | ( | MWAWTable const & | table | ) |
| finalvirtual

open a table

Implements MWAWListener.

## ◆ openTableCell()

void MWAWSpreadsheetListener::openTableCell | ( | MWAWCell const & | cell | ) |
| finalvirtual

open a cell

Implements MWAWListener.

## ◆ openTableRow()

void MWAWSpreadsheetListener::openTableRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = `false`
| ) |  |
| finalvirtual

open a row with given height ( if h < 0.0, set min-row-height = -h )

Implements MWAWListener.

## ◆ operator=()

MWAWSpreadsheetListener& MWAWSpreadsheetListener::operator= | ( | const MWAWSpreadsheetListener & |  | ) |
| private

operator= (unimplemented)

## ◆ setDocumentLanguage()

void MWAWSpreadsheetListener::setDocumentLanguage | ( | std::string const & | locale | ) |
| finalvirtual

sets the documents language

Implements MWAWListener.

## ◆ setDocumentMetaData()

void MWAWSpreadsheetListener::setDocumentMetaData | ( | librevenge::RVNGPropertyList const & | metadata | ) |
| finalvirtual

sets the documents metadata

Implements MWAWListener.

## ◆ setFont()

void MWAWSpreadsheetListener::setFont | ( | MWAWFont const & | font | ) |
| finalvirtual

sets the font

Implements MWAWListener.

Referenced by _flushDeferredTabs().

## ◆ setParagraph()

void MWAWSpreadsheetListener::setParagraph | ( | MWAWParagraph const & | paragraph | ) |
| finalvirtual

sets the paragraph

Implements MWAWListener.

## ◆ startDocument()

void MWAWSpreadsheetListener::startDocument | ( |  | ) |
| finalvirtual

starts the document

Implements MWAWListener.

Referenced by _openPageSpan().

## Member Data Documentation

## ◆ m_documentInterface

librevenge::RVNGSpreadsheetInterface* MWAWSpreadsheetListener::m_documentInterface
| protected

the document interface

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushDeferredTabs(), _flushText(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), addEmptyTableCell(), closeFrame(), closeLink(), closeSheet(), closeSheetCell(), closeSheetRow(), closeTable(), closeTableCell(), closeTableRow(), endDocument(), insertComment(), insertEOL(), insertField(), insertFooter(), insertHeader(), insertNote(), insertPicture(), openFrame(), openLink(), openSheet(), openSheetCell(), openSheetRow(), openTable(), openTableCell(), openTableRow(), and startDocument().

## ◆ m_ds

std::shared_ptr<MWAWSpreadsheetListenerInternal::DocumentState> MWAWSpreadsheetListener::m_ds
| protected

the main parse state

Referenced by _changeList(), _openPageSpan(), _startSubDocument(), closeSheet(), closeSheetRow(), endDocument(), getPageSpan(), getSection(), handleSubDocument(), insertNote(), insertPicture(), isDocumentStarted(), MWAWSpreadsheetListener(), openFrame(), openSheet(), openSheetCell(), openSheetRow(), setDocumentLanguage(), setDocumentMetaData(), and startDocument().

## ◆ m_parserState

MWAWParserState& MWAWSpreadsheetListener::m_parserState
| protected

the parser state

Referenced by _changeList(), _getListId(), _openSpan(), insertCharacter(), openSheetCell(), and openTableCell().

## ◆ m_ps

std::shared_ptr<MWAWSpreadsheetListenerInternal::State> MWAWSpreadsheetListener::m_ps
| protected

the actual local parse state

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _endSubDocument(), _flushDeferredTabs(), _flushText(), _getListId(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), _popParsingState(), _pushParsingState(), _resetParagraphState(), _startSubDocument(), addEmptyTableCell(), canWriteText(), closeFrame(), closeLink(), closeSheetCell(), closeTable(), closeTableCell(), closeTableRow(), endDocument(), getFont(), getPageSpan(), getParagraph(), handleSubDocument(), insertChar(), insertCharacter(), insertComment(), insertEOL(), insertField(), insertFooter(), insertHeader(), insertNote(), insertTab(), insertUnicode(), insertUnicodeString(), isHeaderFooterOpened(), isPageSpanOpened(), isParagraphOpened(), isSubDocumentOpened(), openFrame(), openLink(), openSheet(), openSheetCell(), openTable(), openTableCell(), openTableRow(), setFont(), and setParagraph().

## ◆ m_psStack

std::vector<std::shared_ptr<MWAWSpreadsheetListenerInternal::State> > MWAWSpreadsheetListener::m_psStack
| protected

stack of local state

Referenced by _popParsingState(), and _pushParsingState().

The documentation for this class was generated from the following files:

- MWAWSpreadsheetListener.hxx
- MWAWSpreadsheetListener.cxx